#include <openssl/sha.h>
#include <cryptopp/md5.h>
#include <cryptopp/blake2.h>
#include <openssl/aes.h>// error
#include <string>
#include <iostream>

// 函数：计算给定字符串的SHA-256哈希值
std::string calculateSHA256(const std::string& input) {
    unsigned char hash[SHA256_DIGEST_LENGTH]; // SHA-256哈希值长度为32字节（256位）

    SHA256_CTX sha256;
    SHA256_Init(&sha256); // 初始化上下文

    SHA256_Update(&sha256, input.c_str(), input.size()); // 将输入数据添加到上下文中

    SHA256_Final(hash, &sha256); // 计算哈希值并存储在hash数组中

    // 转换为十六进制字符串形式以便输出或保存
    std::string output;
    for (int i = 0; i < SHA256_DIGEST_LENGTH; ++i) {
        char hex[3] = {0};
        sprintf(hex, "%02x", hash[i]);
        output += hex;
    }

    return output;
}

int main() {
    std::string data = "This is a test string to be hashed with SHA-256.";
    std::cout << "SHA-256 Hash: " << calculateSHA256(data) << std::endl;

    return 0;
}